/* Problem URL: https://codeforces.com/group/YgJmumGtHD/contest/105936/problem/F */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, k;
    cin >> n >> m >> k;

    V<string> fds(n);
    cin >> fds;

    ll valids = 0;

    int ri = -1;
    int rj = -1;

    rep(i, n) {
        rep(j, m) {
            if (fds[i][j] == 'R') {
                ri = i;
                rj = j;
                continue;
            }

            if (fds[i][j] == '.') {
                valids++;
            }
        }
    }

    ll inf = INT64_MAX >> 1;
    vl discount(n * m + 1, 0);

    ll minimal_cheese = inf;
    ll maximal = 0;

    auto bfs = [&](int i, int j) {
        vvl dis(n, vl(m, inf));
        dis[i][j] = 0;
        queue<pair<int, int>> q;
        q.emplace(i, j);

        while (!q.empty()) {
            auto [i, j] = q.front();
            q.pop();

            rmax(maximal, dis[i][j]);

            if (fds[i][j] == 'Q') {
                rmin(minimal_cheese, dis[i][j]);
            } else {
                discount[dis[i][j]]++;
            }

            int add[][2] = {{0, -1}, {0, 1}, {-1, 0}, {1, 0}};

            repv(k, add) {
                int id = i + k[0];
                int jd = j + k[1];
                
                if (id >= 0 && id < n && jd >= 0 && jd < m && fds[id][jd] != '#' && dis[id][jd] > dis[i][j] + 1) {
                    dis[id][jd] = dis[i][j] + 1;
                    q.emplace(id, jd);
                }
            }
        }
    };

    bfs(ri, rj);

    vl suf(n * m + 1);
    for (int i = n * m - 1; i >= 0; i--) {
        suf[i] = suf[i + 1] + discount[i];
    }

    const ll mod = 998244353;

    ll divs = valids;
    nrep(i, 1, k) {
        divs *= (valids - i);
        divs %= mod;
    }

    vl fact(n * m + 1);
    fact[0] = 1;

    nrep(i, 1, n * m + 1) {
        fact[i] = fact[i - 1] * i;
        fact[i] %= mod;
    }

    auto fastpow = [&](ll a, ll b) {
        ll ans = 1;
        ll fds = a;

        rep(i, 31) {
            if ((b >> i) & 1) { ans *= fds;
                ans %= mod;
            }

            fds *= fds;
            fds %= mod;
        }

        return ans;
    };

    auto comb = [&](ll a, ll k) {
        return (fact[a] * fastpow((fact[k] * fact[a - k]) % mod, mod - 2)) % mod;
    };

    auto perm = [&](ll a, ll k) {
        return (fact[a] * fastpow(fact[a - k], mod - 2)) % mod;
    };

    ll ans = 0;

    for (ll i = 1; i <= maximal && i < minimal_cheese; i++) {
        if (suf[i] < k) {
            break;
        }

        if (suf[i + 1] < k) {
            ans += perm(suf[i], k) * i;
            ans %= mod;
            break;
        }

        // ans += ((comb(suf[i], k) - comb(suf[i + 1], k)) % mod + mod) % mod * i;
        ans += ((perm(suf[i], k) - perm(suf[i + 1], k)) % mod + mod) % mod * i;
        ans %= mod;
    }

    if (minimal_cheese != inf && suf[minimal_cheese] >= k) {
        ans += perm(suf[minimal_cheese], k) * minimal_cheese;
        ans %= mod;
    }
    
    cerr << ans << '\n';

    cout << (ans * fastpow(divs, mod - 2)) % mod << '\n';
}
